#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions that do not Belong to Other Categories
#######################################################################

##### Exiting
ExitScript()
{
  echo -n $_COLOR_RESTORE
  exit $1
}

##### Display the title
ShowTitle()
{
  echo -n $_COLOR_NORMAL$_CLEAR_SCREEN
  echo $_COLOR_BLUE"---------------------------------------------------------------------------"$_COLOR_GREEN
  echo "VortexGE $LVER Configuration Script"$_COLOR_YELLOW
  echo "Copyright (C) 2004-2006 Aloysius Indrayanto"
  echo $_COLOR_BLUE"---------------------------------------------------------------------------"$_COLOR_WHITE
  echo "This library is free software; you can redistribute it and/or"
  echo "modify it under the terms of the GNU Lesser General Public"
  echo "License as published by the Free Software Foundation; either"
  echo "version 2.1 of the License, or (at your option) any later version."
  echo ''
  echo "This program is distributed in the hope that it will be useful,"
  echo "but WITHOUT ANY WARRANTY; without even the implied warranty of"
  echo "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU"
  echo "Lesser General Public License for more details."
  echo ''
  echo "You should have received a copy of the GNU Lesser General Public"
  echo "License along with this library; if not, write to the Free Software"
  echo "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA"
  echo $_COLOR_BLUE"---------------------------------------------------------------------------"$_COLOR_PURPLE
  echo ''
}

##### Show usage
ShowUsage()
{
  echo $_COLOR_GREEN"Usage: "$_COLOR_YELLOW"./configure [option]..."$_COLOR_WHITE
  echo ''
  echo $_COLOR_BLUE"Whereas $_COLOR_GREEN[option]$_COLOR_BLUE can be one of :"
  echo ''
  echo $_COLOR_YELLOW'  --help'$_COLOR_WHITE
  echo '      display this help screen'
  echo ''
  echo $_COLOR_YELLOW'  --default [sub-option]...'$_COLOR_WHITE
  echo '      perform non interactive configuration in which the CPU type will be'
  echo '      autodetected and the default options will be used'
  echo ''
  echo "$_COLOR_BLUE      Valid $_COLOR_GREEN[sub-option]s$_COLOR_BLUE are :"
  echo $_COLOR_WHITE
  echo $_COLOR_YELLOW'        --prefix=<target>'$_COLOR_WHITE
  echo '            use the <target> directory as the installation directory'
  echo $_COLOR_YELLOW'        --disable-xf86vm'$_COLOR_WHITE
  echo '            do not detect nor use the xf86 video mode extension in the system'
  echo $_COLOR_YELLOW'        --disable-xshm'$_COLOR_WHITE
  echo '            do not detect nor use the X shared memory extension in the system'
  echo $_COLOR_YELLOW'        --disable-xmu'$_COLOR_WHITE
  echo '            do not detect nor use the X miscellaneous utilities in the system'
  echo $_COLOR_YELLOW'        --disable-png'$_COLOR_WHITE
  echo '            do not detect nor use the libpng in the system'
  echo $_COLOR_YELLOW'        --disable-jpeg'$_COLOR_WHITE
  echo '            do not detect nor use the libjpeg in the system'
  echo $_COLOR_YELLOW'        --disable-tiff'$_COLOR_WHITE
  echo '            do not detect nor use the libtiff in the system'
  echo $_COLOR_YELLOW'        --disable-gif'$_COLOR_WHITE
  echo '            do not detect nor use the libungif (or libgif) in the system'
  echo $_COLOR_YELLOW'        --disable-asm'$_COLOR_WHITE
  echo '            disable inline assembly optimizations'
  echo $_COLOR_YELLOW'        --enable-debug'$_COLOR_WHITE
  echo '            enable debugging information'
  echo $_COLOR_YELLOW'        --enable-static'$_COLOR_WHITE
  echo '            enable static library built'
  echo ''
  echo $_COLOR_YELLOW'  --classic-tui'$_COLOR_WHITE
  echo '      perform interactive configuration with classic TUI even if the dialog'
  echo '      program is usable in the current system (same as setting the environment'
  echo '      variable, VGE_FORCE_CLASSIC_TUI with non empty/null value). This option'
  echo '      can be combined with '$_COLOR_GREEN'--fsave'
  echo $_COLOR_YELLOW'  --fload'$_COLOR_WHITE
  echo '      perform non interactive configuration by loading the options from the'
  echo "      configuration data file \"$ConfDtFile\""
  echo $_COLOR_YELLOW'  --fsave'$_COLOR_WHITE
  echo '      perform interactive configuration and save the selected options to the'
  echo "      configuration data file \"$ConfDtFile\""
  echo $_COLOR_YELLOW'  --clean'$_COLOR_WHITE
  echo '      delete all files created by this configuration script except the saved'
  echo "      configuration data file, \"$ConfDtFile\""
  echo ''
  echo $_COLOR_GREEN"Environment/shell variables:$_COLOR_WHITE"
  echo ''
  echo $_COLOR_YELLOW'  VGE_FORCE_CLASSIC_TUI'$_COLOR_WHITE
  echo '      fill this with any value other than empty/null to make this script'
  echo '      never try to use dialog program even if the dialog program is usable'
  echo '      in the current system (this can be used if the dialog program in the'
  echo '      current system is not working well or not compatible)'
  echo $_COLOR_YELLOW'  VGE_CUSTOM_INC_LOC'$_COLOR_WHITE
  echo '      fill this with nonstandard header files location'
  echo $_COLOR_YELLOW'  VGE_CUSTOM_LIB_LOC'$_COLOR_WHITE
  echo '      fill this with nonstandard library files location'
  echo $_COLOR_NORMAL
}

##### Tell user that the configuration processes are completed
ShowConfComplete()
{
  echo $_COLOR_GREEN"Configuration script completed successfully."
  echo $_COLOR_WHITE
  echo "To display all available makefile rules, type :"$_COLOR_YELLOW
  echo "  make help"$_COLOR_NORMAL
  echo ''
}

##### Tell user that the cleaning processes are completed
ShowCleanComplete()
{
  echo $_COLOR_GREEN"Cleaning process completed successfully."
  echo $_COLOR_NORMAL
}

##### Fix the given directory name
FixDir()
{
  local __Dir__=$1
  local __Len__=${#__Dir__}

  let '__Len__-=1'
  if [[ ${1:$__Len__} != '/' ]]; then
    __Dir__=$__Dir__'/'
  fi

  export $2=$__Dir__
}


#######################################################################
##### Functions for customizing include and library locations
#######################################################################

##### Add custom header files location cumulatively
AddCustomIncludeLocation()
{
  local __dir__

  FixDir $1 __dir__

  if [[ `echo $AddIncLoc | grep $__dir__` == '' ]]; then
    if [[ $__dir__ != '/usr/include/'       ]] && [[ $__dir__ != '/usr/include/sys/'       ]] &&
       [[ $__dir__ != '/usr/local/include/' ]] && [[ $__dir__ != '/usr/local/include/sys/' ]]; then
      AddIncLoc="$AddIncLoc -isystem$__dir__"
    fi
  fi
}

##### Add custom library files location cumulatively
AddCustomLibraryLocation()
{
  local __dir__

  FixDir $1 __dir__

  if [[ `echo $AddLibLoc | grep $__dir__` == '' ]]; then
    if [[ $__dir__ != '/usr/lib/' ]] && [[ $__dir__ != '/usr/local/lib/' ]]; then
      AddLibLoc="$AddLibLoc -L$__dir__"
    fi
  fi
}
