// ############################################################################################
//  VX11Environment3.cc
//  Implementation of CVideoEnv and CVideoStorage classes using X Window system (Xlib)
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// NOTE: This file is meant to be included from within
//       "lib/VideoEnvironment/VideoEnvironment.cc"


namespace vge {

//
// Video enviroment class implementation (X11)
//
void CVideoEnv::DrawIcon2424SCol(int32_t n32X, int32_t n32Y, const uint8_t aun8Data[72])
{
  int32_t idx  = 0;
  int32_t yPos = n32Y;

  for(size_t rowCnt = 0; rowCnt < 24; rowCnt++) {
    int32_t xPos = n32X;
    if(aun8Data[idx] & 0x80) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x40) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x20) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x10) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x08) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x04) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x02) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x01) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    idx++;
    if(aun8Data[idx] & 0x80) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x40) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x20) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x10) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x08) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x04) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x02) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x01) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    idx++;
    if(aun8Data[idx] & 0x80) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x40) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x20) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x10) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x08) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x04) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x02) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    if(aun8Data[idx] & 0x01) XDrawPoint(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC, xPos, yPos); xPos++;
    idx++;
    yPos++;
  }
}

void CVideoEnv::DrawMsgBoxIcon(int32_t n32X, int32_t n32Y, EMsgBoxIcon eVMsgBoxIcon)
{
  // Draw icon border
  SetForegroundColor(_tX11Style.xIconBorder);
  XDrawRectangle(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC,
                 n32X++, n32Y++, 33, 33);
  SetForegroundColor(_tX11Style.xIconBackground);
  SetFillStyle(_tX11Style.xFillStyle);
  XFillRectangle(_tX11.ptDisplay, _tX11.tMainPixmap, _tX11.tMainGC,
                 n32X, n32Y, 32, 32);
  SetFillStyle(FILL_SOLID);

  // Draw the icon
  n32X += 4; n32Y += 4;
  if(eVMsgBoxIcon == EMBI_Information) {
    static const uint8_t aun8I[72] = {
      0x00,0x38,0x00, 0x00,0x38,0x00, 0x00,0x00,0x00,
      0x00,0x00,0x00, 0x00,0x38,0x00, 0x00,0x7C,0x00,
      0x00,0xFC,0x00, 0x00,0xDC,0x00, 0x00,0x1C,0x00,
      0x00,0x1C,0x00, 0x00,0x1C,0x00, 0x00,0x1C,0x00,
      0x00,0x1C,0x00, 0x00,0x1C,0x00, 0x00,0x1C,0x00,
      0x00,0x1C,0x00, 0x00,0x1C,0x00, 0x00,0x1C,0x00,
      0x00,0x1C,0x00, 0x00,0x1C,0x00, 0x00,0x1d,0X80,
      0x00,0x1F,0X80, 0x00,0x1F,0X00, 0x00,0x0E,0X00
    };
    SetForegroundColor(_tX11Style.xIconInformation);
    DrawIcon2424SCol(n32X, n32Y, aun8I);
  }
  else if(eVMsgBoxIcon == EMBI_Question) {
    static const uint8_t aun8Q[72] = {
      0x00,0x3C,0X00, 0x00,0x7E,0x00, 0x00,0xFF,0x00,
      0x01,0xE7,0x80, 0x03,0xC3,0xC0, 0x07,0x81,0xE0,
      0x0F,0x00,0xF0, 0x0E,0x00,0x70, 0x00,0x00,0x70,
      0x00,0x00,0xF0, 0x00,0x01,0xE0, 0x00,0x03,0xC0,
      0x00,0x07,0x80, 0x00,0x0F,0x00, 0x00,0x1E,0x00,
      0x00,0x3C,0x00, 0x00,0x38,0x00, 0x00,0x38,0x00,
      0x00,0x38,0x00, 0x00,0x38,0x00, 0x00,0x00,0x00,
      0x00,0x00,0x00, 0x00,0x38,0x00, 0x00,0x38,0x00
    };
    SetForegroundColor(_tX11Style.xIconQuestion);
    DrawIcon2424SCol(n32X, n32Y, aun8Q);
  }
  else if(eVMsgBoxIcon == EMBI_Warning) {
    static const uint8_t aun8W[72] = {
      0x00,0xFE,0x00, 0x00,0xFE,0x00, 0x00,0xFE,0x00,
      0x00,0xFE,0x00, 0x00,0xFE,0x00, 0x00,0xFE,0x00,
      0x00,0x7C,0x00, 0x00,0x7C,0x00, 0x00,0x7C,0x00,
      0x00,0x7C,0x00, 0x00,0x7C,0x00, 0x00,0x7C,0x00,
      0x00,0x7C,0x00, 0x00,0x7C,0x00, 0x00,0x7C,0x00,
      0x00,0x38,0x00, 0x00,0x38,0x00, 0x00,0x38,0x00,
      0x00,0x38,0x00, 0x00,0x38,0x00, 0x00,0x00,0x00,
      0x00,0x00,0x00, 0x00,0x38,0x00, 0x00,0x38,0x00
    };
    SetForegroundColor(_tX11Style.xIconWarning);
    DrawIcon2424SCol(n32X, n32Y, aun8W);
  }
  else if(eVMsgBoxIcon == EMBI_Error) {
    static const uint8_t aun8E[72] = {
      0x20,0x00,0x04, 0x70,0x00,0x0E, 0xF8,0x00,0x1F,
      0x7C,0x00,0x3E, 0x3E,0x00,0x7C, 0x1F,0x00,0xF8,
      0x0F,0x81,0xF0, 0x07,0xC3,0xE0, 0x03,0xE7,0xC0,
      0x01,0xFF,0x80, 0x00,0xFF,0x00, 0x00,0x7E,0x00,
      0x00,0x7E,0x00, 0x00,0xFF,0x00, 0x01,0xFF,0x80,
      0x03,0xE7,0xC0, 0x07,0xC3,0xE0, 0x0F,0x81,0xF0,
      0x1F,0x00,0xF8, 0x3E,0x00,0x7C, 0x7C,0x00,0x3E,
      0xF8,0x00,0x1F, 0x70,0x00,0x0E, 0x20,0x00,0x04
    };
    SetForegroundColor(_tX11Style.xIconError);
    DrawIcon2424SCol(n32X, n32Y, aun8E);
  }
}

EMsgBoxRetVal CVideoEnv::MessageBox(const string &caption_, const string &text_,
                                    EMsgBoxIcon eIcon_, EMsgBoxButtons eButton_,
                                    EMsgBoxSize eSize_)
{
  // Proxy event handler class
  class _MBE : public CEventHandler {
    public:
      inline _MBE(CVideoEnv      &iVideoEnv,
                  const string   &caption,
                  const string   &text,
                  EMsgBoxIcon     eIcon, 
                  EMsgBoxButtons  eButton,
                  EMsgBoxSize     eSize)
      : CEventHandler(&iVideoEnv),
        _mb          (iVideoEnv, this, caption, text, eIcon, eButton, eSize)
      {}

      virtual ~_MBE() throw()
      {}

      inline bool Exit() const
      { return(_mb.Exit()); }

      inline const EMsgBoxRetVal Result() const
      { return(_mb.GetResult()); }

      virtual void EventKeyPress(EKeySymbol eKeySym, const char *str)
      { _mb.HandleEvent_OnKeyPress(eKeySym, str); }

      virtual void EventButtonPress(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _mb.HandleEvent_OnButtonPress(eButtonSym, posX, posY); }

      virtual void EventButtonRelease(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _mb.HandleEvent_OnButtonRelease(eButtonSym, posX, posY); }

      virtual void EventMouseMove(int32_t posX, int32_t posY, bool btnState[5])
      { _mb.HandleEvent_OnMouseMove(posX, posY, btnState); }

    private:
      CMessageBox _mb;

  } theDialog(*this, caption_, text_, eIcon_, eButton_, eSize_);

  // Execute the dialog loop
  usleep(100000); ClearEvent();
  while(!theDialog.Exit()) {
    if(theDialog.PumpEvents()) theDialog.HandleEvents();
  }
  usleep(100000); ClearEvent();

  // Return the result
  return(theDialog.Result());
}

const string CVideoEnv::InputBox(const string &caption_, const string &defaultText_,
                                 EMsgBoxSize eSize_, ETBType sltbType_, bool sltbEscCancel_,
                                 PFNSLTextBoxCallback pfnSLTBUserCallback_)
{
  // Proxy event handler class
  class _IBE : public CEventHandler {
    public:
      inline _IBE(CVideoEnv           &iVideoEnv,
                  const string        &caption,
                  const string        &defaultText,
                  EMsgBoxSize          eSize,
                  ETBType              sltbType,
                  bool                 sltbEscCancel,
                  PFNSLTextBoxCallback pfnSLTBUserCallback)
      : CEventHandler(&iVideoEnv),
        _ibsl        (iVideoEnv, this, caption, defaultText, eSize, sltbType,
                      sltbEscCancel, pfnSLTBUserCallback)
      {}

      virtual ~_IBE() throw()
      {}

      inline bool Exit() const
      { return(_ibsl.Exit()); }

      inline const string Result() const
      { return(_ibsl.GetResult()); }

      virtual void EventKeyPress(EKeySymbol eKeySym, const char *str)
      { _ibsl.HandleEvent_OnKeyPress(eKeySym, str); }

      virtual void EventButtonPress(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _ibsl.HandleEvent_OnButtonPress(eButtonSym, posX, posY); }

      virtual void EventButtonRelease(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _ibsl.HandleEvent_OnButtonRelease(eButtonSym, posX, posY); }

      virtual void EventMouseMove(int32_t posX, int32_t posY, bool btnState[5])
      { _ibsl.HandleEvent_OnMouseMove(posX, posY, btnState); }

    private:
      CInputBoxSL _ibsl;

  } theDialog(*this, caption_, defaultText_, eSize_, sltbType_,
              sltbEscCancel_, pfnSLTBUserCallback_);

  // Execute the dialog loop
  usleep(100000); ClearEvent();
  while(!theDialog.Exit()) {
    if(theDialog.PumpEvents()) theDialog.HandleEvents();
  }
  usleep(100000); ClearEvent();

  // Return the result
  return(theDialog.Result());
}

const string CVideoEnv::InputBoxML(const string &caption_, const string &defaultText_,
                                   EMsgBoxSize eSize_, bool mltbEscCancel_,
                                   PFNMLTextBoxCallback pfnMLTBUserCallback_)
{
  // Proxy event handler class
  class _IBE : public CEventHandler {
    public:
      inline _IBE(CVideoEnv           &iVideoEnv,
                  const string        &caption,
                  const string        &defaultText,
                  EMsgBoxSize          eSize,
                  bool                 mltbEscCancel,
                  PFNMLTextBoxCallback pfnMLTBUserCallback)
      : CEventHandler(&iVideoEnv),
        _ibml        (iVideoEnv, this, caption, defaultText, eSize,
                      mltbEscCancel, pfnMLTBUserCallback)
      {}

      virtual ~_IBE() throw()
      {}

      inline bool Exit() const
      { return(_ibml.Exit()); }

      inline const string Result() const
      { return(_ibml.GetResult()); }

      virtual void EventKeyPress(EKeySymbol eKeySym, const char *str)
      { _ibml.HandleEvent_OnKeyPress(eKeySym, str); }

      virtual void EventButtonPress(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _ibml.HandleEvent_OnButtonPress(eButtonSym, posX, posY); }

      virtual void EventButtonRelease(EBtnSymbol eButtonSym, int32_t posX, int32_t posY)
      { _ibml.HandleEvent_OnButtonRelease(eButtonSym, posX, posY); }

      virtual void EventMouseMove(int32_t posX, int32_t posY, bool btnState[5])
      { _ibml.HandleEvent_OnMouseMove(posX, posY, btnState); }

    private:
      CInputBoxML _ibml;

  } theDialog(*this, caption_, defaultText_, eSize_,
              mltbEscCancel_, pfnMLTBUserCallback_);

  // Execute the dialog loop
  usleep(100000); ClearEvent();
  while(!theDialog.Exit()) {
    if(theDialog.PumpEvents()) theDialog.HandleEvents();
  }
  usleep(100000); ClearEvent();

  // Return the result
  return(theDialog.Result());
}

void CVideoEnv::_PrepareCreateFont_(const CFontDesc &csFont, string &name1, string &name2, string &name3, vector<string> &fName, vector<string> &pSize)
{
  // Generate the font name in the form of:
  //   "-<foundry>-<family>-<weight>-<slant>-normal--pointSize-*-*-*-<pitch>-*-<registry>-*"
  //    ###########        ##########################         #############################
  //    ## name1 ##        ########## name2 #########         ########### name3 ###########
  //    ###########        ##########################         #############################
  // Example:
  //   "-*-*-medium-r-normal--11-*-*-*-p-*-iso8859-*"
  name1  = "-";
  name1 += csFont.GetFoundry();
  name1 += "-";
  name2  = "-";
  switch(csFont.GetWeight()) {
    case CFontDesc::Weight::Regular: name2 += "medium"; break;
    case CFontDesc::Weight::Bold   : name2 += "bold";   break;
    default                              : name2 += "*";      break;
  };
  name2 += "-";
  switch(csFont.GetSlant()) {
    case CFontDesc::Slant::Normal: name2 += "r"; break;
    case CFontDesc::Slant::Italic: name2 += "i"; break;
    default                            : name2 += "*"; break;
  };
  name2 += "-normal--";
  name3  = "-*-*-*-";
  switch(csFont.GetPitch()) {
    case CFontDesc::Pitch::Monospace   : name3 += "m"; break;
    case CFontDesc::Pitch::Proportional: name3 += "p"; break;
    default                                  : name3 += "*"; break;
  };
  name3 += "-*-";
  name3 += csFont.GetRegistry();
  name3 += "-*";

#undef None // Undefine this xlib macro

  // Check for underline
  if(csFont.GetUnderline() != CFontDesc::Underline::None)
    VWarning(_NFL_, "Only CFontDesc::Underline::None is currently implemented");

  // Parse all parts that can have multiple values
  csFont.ParseFamilyNames(fName);
  csFont.ParsePointSizes(pSize);
}

void CVideoEnv::_InitX11Symbols_()
{
  // Static variables
  bool bInitialized = false;

  // Check
  if(bInitialized) return;
  bInitialized = true;

  // Initialize key symbol
  for(size_t c = 0; c < _MAX_X11_VKS_; c++)
    CVideoEnv::_VKS[c] = VKS_UNKNOWN;

  CVideoEnv::_VKS[XK_BackSpace    & 0x00FF] = VKS_BS;
  CVideoEnv::_VKS[XK_Tab          & 0x00FF] = VKS_TAB;
  CVideoEnv::_VKS[XK_Return       & 0x00FF] = VKS_ENTER;
  CVideoEnv::_VKS[XK_Pause        & 0x00FF] = VKS_PAUSE;
  CVideoEnv::_VKS[XK_Sys_Req      & 0x00FF] = VKS_SYS_REQ;
  CVideoEnv::_VKS[XK_Escape       & 0x00FF] = VKS_ESC;
  CVideoEnv::_VKS[XK_Delete       & 0x00FF] = VKS_DEL;
  CVideoEnv::_VKS[XK_Print        & 0x00FF] = VKS_PRINT;
  CVideoEnv::_VKS[XK_KP_Delete    & 0x00FF] = VKS_KP_PERIOD;
  CVideoEnv::_VKS[XK_KP_Decimal   & 0x00FF] = VKS_KP_PERIOD;
  CVideoEnv::_VKS[XK_KP_0         & 0x00FF] = VKS_KP_0;
  CVideoEnv::_VKS[XK_KP_1         & 0x00FF] = VKS_KP_1;
  CVideoEnv::_VKS[XK_KP_2         & 0x00FF] = VKS_KP_2;
  CVideoEnv::_VKS[XK_KP_3         & 0x00FF] = VKS_KP_3;
  CVideoEnv::_VKS[XK_KP_4         & 0x00FF] = VKS_KP_4;
  CVideoEnv::_VKS[XK_KP_5         & 0x00FF] = VKS_KP_5;
  CVideoEnv::_VKS[XK_KP_6         & 0x00FF] = VKS_KP_6;
  CVideoEnv::_VKS[XK_KP_7         & 0x00FF] = VKS_KP_7;
  CVideoEnv::_VKS[XK_KP_8         & 0x00FF] = VKS_KP_8;
  CVideoEnv::_VKS[XK_KP_9         & 0x00FF] = VKS_KP_9;
  CVideoEnv::_VKS[XK_KP_Insert    & 0x00FF] = VKS_KP_0;
  CVideoEnv::_VKS[XK_KP_End       & 0x00FF] = VKS_KP_1;
  CVideoEnv::_VKS[XK_KP_Down      & 0x00FF] = VKS_KP_2;
  CVideoEnv::_VKS[XK_KP_Page_Down & 0x00FF] = VKS_KP_3;
  CVideoEnv::_VKS[XK_KP_Left      & 0x00FF] = VKS_KP_4;
  CVideoEnv::_VKS[XK_KP_Begin     & 0x00FF] = VKS_KP_5;
  CVideoEnv::_VKS[XK_KP_Right     & 0x00FF] = VKS_KP_6;
  CVideoEnv::_VKS[XK_KP_Home      & 0x00FF] = VKS_KP_7;
  CVideoEnv::_VKS[XK_KP_Up        & 0x00FF] = VKS_KP_8;
  CVideoEnv::_VKS[XK_KP_Page_Up   & 0x00FF] = VKS_KP_9;
  CVideoEnv::_VKS[XK_KP_Divide    & 0x00FF] = VKS_KP_DIV;
  CVideoEnv::_VKS[XK_KP_Multiply  & 0x00FF] = VKS_KP_MUL;
  CVideoEnv::_VKS[XK_KP_Subtract  & 0x00FF] = VKS_KP_SUB;
  CVideoEnv::_VKS[XK_KP_Add       & 0x00FF] = VKS_KP_ADD;
  CVideoEnv::_VKS[XK_KP_Equal     & 0x00FF] = VKS_KP_EQUAL;
  CVideoEnv::_VKS[XK_KP_Enter     & 0x00FF] = VKS_KP_ENTER;
  CVideoEnv::_VKS[XK_Up           & 0x00FF] = VKS_UP;
  CVideoEnv::_VKS[XK_Down         & 0x00FF] = VKS_DOWN;
  CVideoEnv::_VKS[XK_Left         & 0x00FF] = VKS_LEFT;
  CVideoEnv::_VKS[XK_Right        & 0x00FF] = VKS_RIGHT;
  CVideoEnv::_VKS[XK_Insert       & 0x00FF] = VKS_INS;
  CVideoEnv::_VKS[XK_Home         & 0x00FF] = VKS_HOME;
  CVideoEnv::_VKS[XK_End          & 0x00FF] = VKS_END;
  CVideoEnv::_VKS[XK_Page_Up      & 0x00FF] = VKS_PGUP;
  CVideoEnv::_VKS[XK_Page_Down    & 0x00FF] = VKS_PGDN;
  CVideoEnv::_VKS[XK_F1           & 0x00FF] = VKS_F1;
  CVideoEnv::_VKS[XK_F2           & 0x00FF] = VKS_F2;
  CVideoEnv::_VKS[XK_F3           & 0x00FF] = VKS_F3;
  CVideoEnv::_VKS[XK_F4           & 0x00FF] = VKS_F4;
  CVideoEnv::_VKS[XK_F5           & 0x00FF] = VKS_F5;
  CVideoEnv::_VKS[XK_F6           & 0x00FF] = VKS_F6;
  CVideoEnv::_VKS[XK_F7           & 0x00FF] = VKS_F7;
  CVideoEnv::_VKS[XK_F8           & 0x00FF] = VKS_F8;
  CVideoEnv::_VKS[XK_F9           & 0x00FF] = VKS_F9;
  CVideoEnv::_VKS[XK_F10          & 0x00FF] = VKS_F10;
  CVideoEnv::_VKS[XK_F11          & 0x00FF] = VKS_F11;
  CVideoEnv::_VKS[XK_F12          & 0x00FF] = VKS_F12;
  CVideoEnv::_VKS[XK_F13          & 0x00FF] = VKS_F13;
  CVideoEnv::_VKS[XK_F14          & 0x00FF] = VKS_F14;
  CVideoEnv::_VKS[XK_F15          & 0x00FF] = VKS_F15;
  CVideoEnv::_VKS[XK_Caps_Lock    & 0x00FF] = VKS_CAPS_LOCK;
  CVideoEnv::_VKS[XK_Num_Lock     & 0x00FF] = VKS_NUM_LOCK_;
  CVideoEnv::_VKS[XK_Scroll_Lock  & 0x00FF] = VKS_SCROLL_LOCK;
  CVideoEnv::_VKS[XK_Shift_L      & 0x00FF] = VKS_LSHIFT;
  CVideoEnv::_VKS[XK_Shift_R      & 0x00FF] = VKS_RSHIFT;
  CVideoEnv::_VKS[XK_Control_L    & 0x00FF] = VKS_LCTRL;
  CVideoEnv::_VKS[XK_Control_R    & 0x00FF] = VKS_RCTRL;
  CVideoEnv::_VKS[XK_Alt_R        & 0x00FF] = VKS_LALT;
  CVideoEnv::_VKS[XK_Alt_L        & 0x00FF] = VKS_RALT;
  CVideoEnv::_VKS[XK_Menu         & 0x00FF] = VKS_MENU;
  CVideoEnv::_VKS[XK_Help         & 0x00FF] = VKS_HELP;
  CVideoEnv::_VKS[XK_Print        & 0x00FF] = VKS_PRINT;
  CVideoEnv::_VKS[XK_Break        & 0x00FF] = VKS_BREAK;
  CVideoEnv::_VKS[XK_Meta_L       & 0x00FF] = VKS_LMETA;
  CVideoEnv::_VKS[XK_Meta_R       & 0x00FF] = VKS_RMETA;
  CVideoEnv::_VKS[XK_Super_L      & 0x00FF] = VKS_LSUPER;
  CVideoEnv::_VKS[XK_Super_R      & 0x00FF] = VKS_RSUPER;
  CVideoEnv::_VKS[XK_Hyper_L      & 0x00FF] = VKS_LHYPER;
  CVideoEnv::_VKS[XK_Hyper_R      & 0x00FF] = VKS_RHYPER;
  CVideoEnv::_VKS[XK_Clear        & 0x00FF] = VKS_CLEAR;
  CVideoEnv::_VKS[XK_Mode_switch  & 0x00FF] = VKS_MODE;
  CVideoEnv::_VKS[XK_Multi_key    & 0x00FF] = VKS_COMPOSE;

  // Initialize button symbol
  for(size_t c = 0; c < _MAX_X11_VBS_; c++)
    CVideoEnv::_VBS[c] = VBS_UNKNOWN;
  
  CVideoEnv::_VBS[Button1] = VBS_MB1;
  CVideoEnv::_VBS[Button2] = VBS_MB2;
  CVideoEnv::_VBS[Button3] = VBS_MB3;
  CVideoEnv::_VBS[Button4] = VBS_MB4;
  CVideoEnv::_VBS[Button5] = VBS_MB5;
}

void CVideoEnv::_CreateColorMap_(bool bUseExclusiveColormap)
{
  // Check
  if((_tX11.un32Depth != 8) || (!bUseExclusiveColormap)) {
    _tX11.tColormap = DefaultColormap(_tX11.ptDisplay, _tX11.n32Screen);
    _tX11.un32BlackPixel = BlackPixel(_tX11.ptDisplay, _tX11.n32Screen);
    _tX11.un32WhitePixel = WhitePixel(_tX11.ptDisplay, _tX11.n32Screen);
    return;
  }

  // Create color map
  _tX11.tColormap = XCreateColormap(_tX11.ptDisplay, _tX11.tRootWindow, _tX11.ptVisual, AllocNone);

  // Allocate memory
  _tX11.tColormapData.ptColors = reinterpret_cast<XColor*>(malloc(sizeof(XColor) * 216));
  if(_tX11.tColormapData.ptColors == NULL) {
    _tX11.tColormap = DefaultColormap(_tX11.ptDisplay, _tX11.n32Screen);
    VError(VERR_NotEnoughMemory, _NFL_, "Couldn't allocate memory for colormap colors");
  }

  // Allocate color cells
  u_long aulColors[216];
  u_long *pulDummy = NULL;

  if(!XAllocColorCells(_tX11.ptDisplay, _tX11.tColormap, 0,
                       pulDummy, 0, aulColors, 216)) {
    free(_tX11.tColormapData.ptColors);
    _tX11.tColormapData.ptColors = NULL;
    _tX11.tColormap = DefaultColormap(_tX11.ptDisplay, _tX11.n32Screen);
    VError(VERR_NotEnoughMemory, _NFL_, "Couldn't allocate color cells");
  }


  // Create color data
  for(size_t i = 0; i < 216; i++) {
    _tX11.tColormapData.ptColors[i].pixel = aulColors[i];
    _tX11.tColormapData.ptColors[i].flags = DoRed | DoGreen | DoBlue;
  }

  uint32_t aun32Vals[6] = {0, 13107, 26214, 39321, 52428, 65535 };
  size_t   cCnt         = 0;
  for(size_t r = 0; r < 6; r++) {
    for(size_t g = 0; g < 6; g++) {
      for(size_t b = 0; b < 6; b++) {
        _tX11.tColormapData.ptColors[cCnt].red   = aun32Vals[r];
        _tX11.tColormapData.ptColors[cCnt].green = aun32Vals[g];
        _tX11.tColormapData.ptColors[cCnt].blue  = aun32Vals[b];
        cCnt++;
      }
    }
  }

  // Store colors
  XStoreColors(_tX11.ptDisplay, _tX11.tColormap, _tX11.tColormapData.ptColors, 216);
  _tX11.un32BlackPixel = 0;
  _tX11.un32WhitePixel = 215;
  _tX11.tColormapData.count = 216;
}

void CVideoEnv::_InitColorLUT_()
{
#ifdef __USE_DITHERING_FOR_8BPP__
  // Allocate memory for the color conversion LUT
  _tRI.pucLUT = reinterpret_cast<u_char*>(malloc(256));
#else
  _tRI.pucLUT = reinterpret_cast<u_char*>(malloc(32 * 32 * 32));
#endif
  if(_tRI.pucLUT == NULL)
    VError(VERR_NotEnoughMemory, _NFL_, "Couldn't allocate memory for color translation LUT");

  // Generate LUT
#ifdef __USE_DITHERING_FOR_8BPP__
  for(uint16_t cR = 0; cR <= 7; ++cR) {
    for(uint16_t cG = 0; cG <= 7; ++cG) {
      for(uint16_t cB = 0; cB <= 3; ++cB) {
#else
  for(uint16_t cR = 0; cR <= 31; ++cR) {
    for(uint16_t cG = 0; cG <= 31; ++cG) {
      for(uint16_t cB = 0; cB <= 31; ++cB) {
#endif
        // Scale the color components
#ifdef __USE_DITHERING_FOR_8BPP__
        uint16_t un16R1 = cR * uint16_t( 9362);
        uint16_t un16G1 = cG * uint16_t( 9362);
        uint16_t un16B1 = cB * uint16_t(21845);
#else
        uint16_t un16R1 = cR * uint16_t(2114);
        uint16_t un16G1 = cG * uint16_t(2114);
        uint16_t un16B1 = cB * uint16_t(2114);
#endif
        uint32_t un32I1 = uint32_t(sqrt((uint32_t(un16R1 >> 8) * uint32_t(un16R1 >> 8)) +
                                        (uint32_t(un16G1 >> 8) * uint32_t(un16G1 >> 8)) +
                                        (uint32_t(un16B1 >> 8) * uint32_t(un16B1 >> 8))));
        // Search for the closest match in the palette
        uint8_t   un8CSel  = 0;
        uint32_t  un32DMin = 0xFFFFFFFF;
        uint16_t *pun16Tmp = _tRI.pun16Pal;
        for(uint16_t un16C = 0; un16C <= 255; un16C++) {
          // Extract the color information
          uint16_t un16Fl = *pun16Tmp++;
          uint16_t un16R2 = *pun16Tmp++;
          uint16_t un16G2 = *pun16Tmp++;
          uint16_t un16B2 = *pun16Tmp++;
          // Check only if the color cell is usable
          if(un16Fl) {
            uint32_t un32I2 = uint32_t(sqrt((uint32_t(un16R2 >> 8) * uint32_t(un16R2 >> 8)) +
                                            (uint32_t(un16G2 >> 8) * uint32_t(un16G2 >> 8)) +
                                            (uint32_t(un16B2 >> 8) * uint32_t(un16B2 >> 8))));
            uint32_t un32DR = ((un16R2 > un16R1) ? (un16R2 - un16R1) : (un16R1 - un16R2)) >> 3;
            uint32_t un32DG = ((un16G2 > un16G1) ? (un16G2 - un16G1) : (un16G1 - un16G2)) >> 3;
            uint32_t un32DB = ((un16B2 > un16B1) ? (un16B2 - un16B1) : (un16B1 - un16B2)) >> 3;
            uint32_t un32DI = ((un32I2 > un32I1) ? (un32I2 - un32I1) : (un32I1 - un32I2)) << 4;
            uint32_t un32D  = (un32DR * un32DR) + (un32DG * un32DG) + (un32DB * un32DB) + (un32DI * un32DI);
            if(un32D < un32DMin) {
              un32DMin = un32D;
              un8CSel  = un16C;
            }
          }
        }
  
#ifdef __USE_DITHERING_FOR_8BPP__
        // Save the result in LUT, indexed by true color RGB332 values
        _tRI.pucLUT[(cR << 5) | (cG << 2) | cB] = un8CSel;
#else
        // Save the result in LUT, indexed by true color RGB555 values
        _tRI.pucLUT[(uint32_t(cR) << 10) | (uint32_t(cG) << 5) | uint32_t(cB)] = un8CSel;
#endif
      }
    }
  }
}

void CVideoEnv::_CreateDefaultFonts_()
{
  _tX11.ptDefFontSmall    = CreateFont(CFontDesc::DefaultSmallFont);
  _tX11.ptDefFontBig      = CreateFont(CFontDesc::DefaultBigFont);
  _tX11.ptDefFontSetSmall = CreateUtf8Font(CFontDesc::DefaultUtf8SmallFont);
  _tX11.ptDefFontSetBig   = CreateUtf8Font(CFontDesc::DefaultUtf8BigFont);
}

void CVideoEnv::_CreateDefaultCursors_()
{
  // Temporary variables
  XColor tDummy, tFore, tBack;
  Pixmap tTmp, tCursor, tMask;
  uint16_t an16Arrow[]     = _VX11CUR_ARROW_;
  uint16_t an16ArrowMask[] = _VX11CUR_ARROW_MASK_;
  uint16_t an16Wait[]      = _VX11CUR_WAIT_;
  uint16_t an16WaitMask[]  = _VX11CUR_WAIT_MASK_;

  // Create default "arrow" cursor
  XLookupColor(_tX11.ptDisplay, _tX11.tColormap, "white", &tDummy, &tFore);
  XLookupColor(_tX11.ptDisplay, _tX11.tColormap, "black", &tDummy, &tBack);
  tTmp    = XCreatePixmap(_tX11.ptDisplay, _tX11.tRootWindow, 1, 1, 1);
  tCursor = XCreatePixmapFromBitmapData(_tX11.ptDisplay, tTmp, reinterpret_cast<char*>(an16Arrow),
                                        _VX11CUR_ARROW_X_SIZE_, _VX11CUR_ARROW_Y_SIZE_, 1, 0, 1);
  tMask   = XCreatePixmapFromBitmapData(_tX11.ptDisplay, tTmp, reinterpret_cast<char*>(an16ArrowMask),
                                        _VX11CUR_ARROW_X_SIZE_, _VX11CUR_ARROW_Y_SIZE_, 1, 0, 1);
  _tX11.tDefCurArrow = XCreatePixmapCursor(_tX11.ptDisplay, tCursor, tMask, &tFore, &tBack,
                                        _VX11CUR_ARROW_X_HP_, _VX11CUR_ARROW_Y_HP_);
  XFreePixmap(_tX11.ptDisplay, tTmp);
  XFreePixmap(_tX11.ptDisplay, tCursor);
  XFreePixmap(_tX11.ptDisplay, tMask);

  // Create default "wait" cursor
  XLookupColor(_tX11.ptDisplay, _tX11.tColormap, "white", &tDummy, &tFore);
  XLookupColor(_tX11.ptDisplay, _tX11.tColormap, "black", &tDummy, &tBack);
  tTmp    = XCreatePixmap(_tX11.ptDisplay, _tX11.tRootWindow, 1, 1, 1);
  tCursor = XCreatePixmapFromBitmapData(_tX11.ptDisplay, tTmp, reinterpret_cast<char*>(an16Wait),
                                        _VX11CUR_WAIT_X_SIZE_, _VX11CUR_WAIT_Y_SIZE_, 1, 0, 1);
  tMask   = XCreatePixmapFromBitmapData(_tX11.ptDisplay, tTmp, reinterpret_cast<char*>(an16WaitMask),
                                        _VX11CUR_WAIT_X_SIZE_, _VX11CUR_WAIT_Y_SIZE_, 1, 0, 1);
  _tX11.tDefCurWait = XCreatePixmapCursor(_tX11.ptDisplay, tCursor, tMask, &tFore, &tBack,
                                        _VX11CUR_WAIT_X_HP_, _VX11CUR_WAIT_Y_HP_);
  XFreePixmap(_tX11.ptDisplay, tTmp);
  XFreePixmap(_tX11.ptDisplay, tCursor);
  XFreePixmap(_tX11.ptDisplay, tMask);
}

void CVideoEnv::_LoadXPMFromFile_(const char *xpmFileName, Pixmap *dstPixmap, Pixmap *dstMask, uint32_t *widthRet, uint32_t *heightRet) const
{
  vassert(xpmFileName, "The 'xpmFileName' parameter must not NULL");

  // Generate XPM attributes
  XpmAttributes a;
  memset(&a, 0, sizeof(a));
  a.valuemask = XpmVisual | XpmColormap | XpmDepth;
  a.visual    = _tX11.ptVisual;
  a.colormap  = _tX11.tColormap;
  a.depth     = _tX11.un32Depth;
  if(_tX11.un32Depth == 8) {
    //! \todo Later, we should dither the XPM
    a.valuemask |= XpmCloseness;
    a.closeness  = 65535;
  }

  // Load XPM
  Pixmap i = 0;
  Pixmap m = 0;
  int    ret = XpmReadFileToPixmap(_tX11.ptDisplay, _tX11.tMainWindow,
                                   const_cast<char*>(xpmFileName),
                                   &i, &m, &a);
  if(ret != XpmSuccess)
    VError(VERR_ReadStream, _NFL_, "XpmError: %s (\"%s\")", XpmGetErrorString(ret), xpmFileName);

  // Copy variables
  *dstPixmap = i;
  *dstMask   = m;
  if(widthRet)  *widthRet  = a.width;
  if(heightRet) *heightRet = a.height;
}

void CVideoEnv::_LoadXPMFromMemory_(const char *xpmDataBuffer[], Pixmap *dstPixmap, Pixmap *dstMask, uint32_t *widthRet, uint32_t *heightRet) const
{
  vassert(xpmDataBuffer, "The 'xpmDataBuffer' parameter must not NULL");

  // Generate XPM attributes
  XpmAttributes a;
  memset(&a, 0, sizeof(a));
  a.valuemask = XpmVisual | XpmColormap | XpmDepth;
  a.visual    = _tX11.ptVisual;
  a.colormap  = _tX11.tColormap;
  a.depth     = _tX11.un32Depth;
  if(_tX11.un32Depth == 8) {
    //! \todo Later, we should dither the XPM
    a.valuemask |= XpmCloseness;
    a.closeness  = 65535;
  }

  // Load XPM
  Pixmap i = 0;
  Pixmap m = 0;
  int    ret = XpmCreatePixmapFromData(_tX11.ptDisplay, _tX11.tMainWindow,
                                       const_cast<char**>(xpmDataBuffer),
                                       &i, &m, &a);
  if(ret != XpmSuccess)
    VError(VERR_ReadStream, _NFL_, "XpmError: %s", XpmGetErrorString(ret));

  // Copy the pointer
  *dstPixmap = i;
  *dstMask   = m;
  if(widthRet)  *widthRet  = a.width;
  if(heightRet) *heightRet = a.height;
}

void CVideoEnv::_SetWindowIcon_(Pixmap *ptIcon, Pixmap *ptIconMask)
{
  // Temporary variables
  XWMHints *ptWMH;

  // Set the icon
  ptWMH = XAllocWMHints();
  if(ptWMH) {
    ptWMH->flags       = IconPixmapHint | IconMaskHint;
    ptWMH->icon_pixmap = *ptIcon;
    ptWMH->icon_mask   = *ptIconMask;
    XSetWMHints(_tX11.ptDisplay, _tX11.tMainWindow, ptWMH);
    XFree(ptWMH);
  }
}

void CVideoEnv::_Set_NET_WM_STATE_(uint32_t un32ActionCode, const char *pcAtomName1, const char *pcAtomName2)
{
  // Note that in order for this to work :
  //   1. The running window manager must support _NET_WM_STATE protocol
  //   2. The window must be mapped

  // Temporary variables
  XEvent tXEvent;

  // Prepare the event structure
  memset(&tXEvent, 0, sizeof(tXEvent));
  tXEvent.xclient.type         = ClientMessage;
  tXEvent.xclient.message_type = xprv::_x11Atom_NET_WM_STATE;
  tXEvent.xclient.display      = _tX11.ptDisplay;
  tXEvent.xclient.window       = _tX11.tMainWindow;
  tXEvent.xclient.format       = 32;
  tXEvent.xclient.data.l[0]    = un32ActionCode;
  tXEvent.xclient.data.l[1]    = XInternAtom(_tX11.ptDisplay, pcAtomName1, False);
  if(pcAtomName2)
    tXEvent.xclient.data.l[2]  = XInternAtom(_tX11.ptDisplay, pcAtomName2, False);

  // Send the request
  XSendEvent(_tX11.ptDisplay, _tX11.tRootWindow, False, SubstructureNotifyMask | SubstructureRedirectMask, &tXEvent);
  XSync(_tX11.ptDisplay, False);
}

void CVideoEnv::_ToggleFullscreen_(bool bActive)
{
  // Toggle to windowed
  if((_pcsFSOwner_ == this) && (_pcsFSHoldr_ == NULL) && (!bActive)) {
    _pcsFSHoldr_ = _pcsFSOwner_;
    SetFullscreen(false);
  }
  // Toggle to fullscreen
  else if((_pcsFSOwner_ == NULL) && (_pcsFSHoldr_ == this) && bActive) {
    SetFullscreen(true);
    _pcsFSHoldr_ = NULL;
  }
}

void CVideoEnv::_ConvertRB2RI24Bpp_()
{
  const uint32_t *src = reinterpret_cast<uint32_t*>(_tRB.pun8Buffer);
  uint32_t       *dst = reinterpret_cast<uint32_t*>(_tRI.pucImage);

  CopyMem4X8(dst, src, _tRB.un32Size48);
}

void CVideoEnv::_ConvertRB2RI16Bpp555_()
{
  const uint8_t *src = _tRB.pun8Buffer;
  uint16_t      *dst = reinterpret_cast<uint16_t*>(_tRI.pucImage);

  for(size_t c = 0; c < _tRI.un32Dim; ++c) {
    *dst++ = (src[0] >> 3) | (src[1] << 2) | (src[2] << 7);
    src += 4;
  }
}

void CVideoEnv::_ConvertRB2RI16Bpp565_()
{
  const uint8_t *src = _tRB.pun8Buffer;
  uint16_t      *dst = reinterpret_cast<uint16_t*>(_tRI.pucImage);

  for(size_t c = 0; c < _tRI.un32Dim; ++c) {
    *dst++ = (src[0] >> 3) | (src[1] << 3) | (src[2] << 8);
    src += 4;
  }
}

void CVideoEnv::_ConvertRB2RI8Bpp_()
{
#ifdef __USE_DITHERING_FOR_8BPP__

  const uint32_t *src = reinterpret_cast<uint32_t*>(_tRB.pun8Buffer);
  u_char         *dst = _tRI.pucImage;

#if defined(_ASM_SSE_) || defined(_ASM_3DNOW_)
  asm volatile
  (
#ifdef _ASM_SSE_
    "prefetcht0    (%0) \n\t"
    "prefetcht0  64(%0) \n\t"
    "prefetcht0 128(%0) \n\t"
    "prefetcht0 192(%0)     "
#else
    "prefetch    (%0) \n\t"
    "prefetch  64(%0) \n\t"
    "prefetch 128(%0) \n\t"
    "prefetch 192(%0)     "
#endif
    : : "r" (_tRI.pucLUT)
  );
#endif

  for(size_t y = 0; y < _tRI.un32Height; ++y) {
    for (size_t x = 0; x < _tRI.un32Width; ++x) {
      *dst++ = _tRI.pucLUT[xprv::_DitherRGB88ToRGB332_(*src++, x, y)];
    }
  }
#else
  const uint8_t *src = _tRB.pun8Buffer;
  u_char        *dst = _tRI.pucImage;

  for(size_t c = 0; c < _tRI.un32Dim; ++c) {
    *dst++ = _tRI.pucLUT[(uint32_t(src[2]) << 7) | (uint32_t(src[1]) << 2) | (uint32_t(src[0]) >> 3)];
    src += 4;
  }
#endif
}

void CVideoEnv::_ConvertRB2RI24BppScl_()
{
  const size_t    srcW = _tRB.un32Width;
  const size_t    srcH = _tRB.un32Height;
  const uint32_t *src  = reinterpret_cast<uint32_t*>(_tRB.pun8Buffer);

  const size_t    dstW = _tRI.un32Width;
  const size_t    dstH = _tRI.un32Height;
        uint32_t *dst  = reinterpret_cast<uint32_t*>(_tRI.pucImage);

  // Perform integer-scan scaling
  size_t dh = 0;
  size_t y  = 0;
  while(y < dstH) {
    // Backup the source pointer of this row
    const uint32_t *sln = src;
    // Scale in the horizontal direction
    do {
      // Pointer to the position after the rightmost pixel in this row
      const uint32_t *dse = dst + dstW;
      // Scaling loop
      size_t dw = 0;
      while(dst < dse) {
        // Put the pixel and adjust the source pointer to the next pixel in this row
        *dst++ = *src;
        for(dw += srcW; dw >= dstW; ++src, dw -= dstW);
      }
      // Restore the source pointer and increment the Y position
      src = sln;
      y++;
    } while((dh += srcH) < dstH);
    // Adjust the source pointer to the next row
    while(dh >= dstH) {
      src += srcW;
      dh -= dstH;
    }
  }
}

void CVideoEnv::_ConvertRB2RI16BppScl555_()
{
  const size_t   srcW = _tRB.un32Width;
  const size_t   srcP = srcW << 2;
  const size_t   srcH = _tRB.un32Height;
  const uint8_t *src  = _tRB.pun8Buffer;

  const size_t    dstW = _tRI.un32Width;
  const size_t    dstH = _tRI.un32Height;
        uint16_t *dst  = reinterpret_cast<uint16_t*>(_tRI.pucImage);

  // Perform integer-scan scaling
  size_t dh = 0;
  size_t y  = 0;
  while(y < dstH) {
    // Backup the source pointer of this row
    const uint8_t *sln = src;
    // Scale in the horizontal direction
    do {
      // Pointer to the position after the rightmost pixel in this row
      const uint16_t *dse = dst + dstW;
      // Scaling loop
      size_t dw = 0;
      while(dst < dse) {
        // Put the pixel and adjust the source pointer to the next pixel in this row
        *dst++ = (src[0] >> 3) | (src[1] << 2) | (src[2] << 7);
        for(dw += srcW; dw >= dstW; src+=4, dw -= dstW);
      }
      // Restore the source pointer and increment the Y position
      src = sln;
      y++;
    } while((dh += srcH) < dstH);
    // Adjust the source pointer to the next row
    while(dh >= dstH) {
      src += srcP;
      dh -= dstH;
    }
  }
}

void CVideoEnv::_ConvertRB2RI16BppScl565_()
{
  const size_t   srcW = _tRB.un32Width;
  const size_t   srcP = srcW << 2;
  const size_t   srcH = _tRB.un32Height;
  const uint8_t *src  = _tRB.pun8Buffer;

  const size_t    dstW = _tRI.un32Width;
  const size_t    dstH = _tRI.un32Height;
        uint16_t *dst  = reinterpret_cast<uint16_t*>(_tRI.pucImage);

  // Perform integer-scan scaling
  size_t dh = 0;
  size_t y  = 0;
  while(y < dstH) {
    // Backup the source pointer of this row
    const uint8_t *sln = src;
    // Scale in the horizontal direction
    do {
      // Pointer to the position after the rightmost pixel in this row
      const uint16_t *dse = dst + dstW;
      // Scaling loop
      size_t dw = 0;
      while(dst < dse) {
        // Put the pixel and adjust the source pointer to the next pixel in this row
        *dst++ = (src[0] >> 3) | (src[1] << 3) | (src[2] << 8);
        for(dw += srcW; dw >= dstW; src+=4, dw -= dstW);
      }
      // Restore the source pointer and increment the Y position
      src = sln;
      y++;
    } while((dh += srcH) < dstH);
    // Adjust the source pointer to the next row
    while(dh >= dstH) {
      src += srcP;
      dh -= dstH;
    }
  }
}

void CVideoEnv::_ConvertRB2RI8BppScl_()
{
  const size_t    srcW = _tRB.un32Width;
#ifndef __USE_DITHERING_FOR_8BPP__
  const size_t    srcP = srcW << 2;
#endif
  const size_t    srcH = _tRB.un32Height;
#ifdef __USE_DITHERING_FOR_8BPP__
  const uint32_t *src  = reinterpret_cast<uint32_t*>(_tRB.pun8Buffer);
#else
  const uint8_t  *src  = _tRB.pun8Buffer;
#endif

  const size_t  dstW = _tRI.un32Width;
  const size_t  dstH = _tRI.un32Height;
        u_char *dst  = _tRI.pucImage;

#if defined(__USE_DITHERING_FOR_8BPP__) && (defined(_ASM_SSE_) || defined(_ASM_3DNOW_))
  asm volatile
  (
#ifdef _ASM_SSE_
    "prefetcht0    (%0) \n\t"
    "prefetcht0  64(%0) \n\t"
    "prefetcht0 128(%0) \n\t"
    "prefetcht0 192(%0)     "
#else
    "prefetch    (%0) \n\t"
    "prefetch  64(%0) \n\t"
    "prefetch 128(%0) \n\t"
    "prefetch 192(%0)     "
#endif
    : : "r" (_tRI.pucLUT)
  );
#endif

  // Perform integer-scan scaling
  size_t dh = 0;
  size_t y  = 0;
  while(y < dstH) {
    // Backup the source pointer of this row
#ifdef __USE_DITHERING_FOR_8BPP__
    const uint32_t *sln = src;
#else
    const uint8_t *sln = src;
#endif
    // Scale in the horizontal direction
    do {
      // Scaling loop
      size_t dw = 0;
      for(size_t x = 0; x < dstW; ++x) {
        // Put the pixel and adjust the source pointer to the next pixel in this row
#ifdef __USE_DITHERING_FOR_8BPP__
        *dst++ =_tRI.pucLUT[xprv::_DitherRGB88ToRGB332_(*src, x, y)];
        for(dw += srcW; dw >= dstW; ++src, dw -= dstW);
#else
        *dst++ = _tRI.pucLUT[(uint32_t(src[2]) << 7) | (uint32_t(src[1]) << 2) | (uint32_t(src[0]) >> 3)];
        for(dw += srcW; dw >= dstW; src+=4, dw -= dstW);
#endif
      }
      // Restore the source pointer and increment the Y position
      src = sln;
      y++;
    } while((dh += srcH) < dstH);
    // Adjust the source pointer to the next row
    while(dh >= dstH) {
#ifdef __USE_DITHERING_FOR_8BPP__
      src += srcW;
#else
      src += srcP;
#endif
      dh -= dstH;
    }
  }
}

} // namespace vge
