// ############################################################################################
//  roomedit-DlgPages-PNS.h
//  Definition & implememtation of roomedit's CPage_PNS class
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This program is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################
#ifndef _UTIL___ROOMEDIT_DLGPAGES_PNS_H_
#define _UTIL___ROOMEDIT_DLGPAGES_PNS_H_

// VortexGE headers
#include <VMain.h>


// Foward reference of the application class
class CRoomEdit;

// Foward reference of the dialog main page
class CPage_Main;


//
// Used for storing plane settings
//
struct TInit_PlaneSettings {
  string    planeName;
  uint32_t  planeRowSize;
  uint32_t  planeColSize;
  EPlaneDir planeDir;
};


//
// Our dialog page: Plane Settings
//
class CPage_PNS : public CDialogPage {
  public:
    typedef void(CPage_Main::*PFNToInvoke)(const TInit_PlaneSettings &init);

  public:
    CPage_PNS(CPage_Main &mainPage);
    virtual ~CPage_PNS() throw();

    // Management functions
    void SetPlaneSettings(const TInit_PlaneSettings *init);
    inline void SetFuncToInvoke(PFNToInvoke pfnTI)
    { _pfnTI = pfnTI; }

    // Controls' event handlers
    void _onBtnOK(_CControl *ctrl);
    void _onBtnCancel(_CControl *ctrl);
    void _onRdoDirs(_CControl *ctrl);

    // Reimplemented from CDialogPage
    virtual void InitializeAllControls();

    // Reimplemented from CDialogPage
    virtual void HandleEvent_OnKeyPress(EKeySymbol keySymbol, const char *str);

  protected:
    // Main data
    CRoomEdit        &_app;
    CPage_Main       &_mPage;
    CVideoStorage     _vStrg;
    PFNToInvoke       _pfnTI;
    // Controls: Main section
    CPanelBar         pbrMain;
    CHLayout          hlyMain;
    CVLayout          vlyBtn;
    CButton           btnOK;
    CButton           btnCancel;
    // Controls: Name section
    CHLayout          hlyName;
    CLabel            lblName;
    CSLTextBox        txtName;
    // Controls: Settings section
    CFrame            fraSettings;
    CHVLayoutCompound hvgSettings;
    CLabel            lblRow;
    CSpinButton       spnRow;
    CLabel            lblCol;
    CSpinButton       spnCol;
    CLabel            lblDir;
    CImageDisplay     idsDir;
    CRadioButton      rdoDirs[6];
    CLabel            lblDirInfo;
};

#endif
